<?php
/*
+---------------------------------------------------------------+
|	e107 website system
|	e107_plugins.php/imagegallery_menu/thumb.php
|
|       Mark Pustjens 2003
|	http://unkie.org
|	mark@unkie.org

|       Steve Dunstan 2001-2002
|       http://e107.org
|       jalist@e107.org
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).	
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

/*----------- Handle Thumbnailing -------------*/
if (e_QUERY){
  list($source, $newsize) = explode ('+', e_QUERY);
  resize_image($source, $newsize);

}

function resize_image($source_file, $new_size){
        global $pref;

        $mode = ($pref['resize_method'] ? $pref['resize_method'] : "gd2");
        //if($mode == "ImageMagick"){ $mode = 'gd2'; }

        $im_quality = ($pref['im_quality'] ? $pref['im_quality'] : 75);

        $image_stats = getimagesize($source_file);
        if($image_stats == null){ return false; }

        if ($image_stats[2] != 2 && $image_stats[2] != 3 && ($mode == 'gd1' || $mode == 'gd2')){
                return FALSE;
        }

        $imagewidth = $image_stats[0];
        if($imagewidth <= $new_size){ $new_size = $imagewidth; }
        $imageheight = $image_stats[1];
        $ratio = ($imagewidth / $new_size);
        $new_imageheight = round($imageheight / $ratio);

        if($mode == "ImageMagick"){
                $destination_file = 'jpg:-';
		header("Content-type: image/jpeg");
                passthru($pref['im_path']."convert -quality ".$im_quality." -antialias -geometry ".$new_size."x".$new_imageheight." ".$source_file." ".$destination_file);

        }else if($mode == "gd1"){
                if($image_stats[2] == 2)
                        $src_img = imagecreatefromjpeg($source_file);
                else
                        $src_img = imagecreatefrompng($source_file);
                if(!$src_img){
                        return FALSE;
                }
                $dst_img = imagecreate($new_size, $new_imageheight);
                imagecopyresized($dst_img, $src_img, 0, 0, 0, 0, $new_size, $new_imageheight, $imagewidth, $imageheight);
		header("Content-type: image/jpeg");
                imagejpeg($dst_img, '', $im_quality);
                imagedestroy($src_img);
                imagedestroy($dst_img);

        }else if($mode == "gd2"){

                if ($image_stats[2] == 2)
                        $src_img = imagecreatefromjpeg($source_file);
                else
                        $src_img = imagecreatefrompng($source_file);
                if (!$src_img){
                        return FALSE;
                }

                $dst_img = imagecreatetruecolor($new_size, $new_imageheight);
                imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $new_size, $new_imageheight, $imagewidth, $imageheight);
		header("Content-type: image/jpeg");
                imagejpeg($dst_img, '', $im_quality);
                imagedestroy($src_img);
                imagedestroy($dst_img);
        }
}

?>
